﻿@model eCommerce.Services.Model.Purchase
@using eCommerce.Services.Model.Enums

@{
    ViewBag.Title = "Compras";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Compra</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("PurchaseUpdate", "Purchases", FormMethod.Post, new { @class= "validation",@autocomplete = "off" }))
                    {
                        <div class="row">
                            <div class="form-group col-sm-3">
                                <label class="control-label">Fecha de Compra</label>
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="Date" value="@(Model.Date != DateTime.MinValue ? Model.Date.ToShortDateString() : DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                </div>
                            </div>
                            <div class="form-group col-sm-5">
                                <label class="control-label">Proveedor</label>
                                <select class="form-control" name="SupplierId" id="SupplierId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    @if (TempData["Suppliers"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Suppliers"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                            <div class="form-group col-sm-2">
                                <label class="control-label">Moneda</label>
                                <select class="form-control" name="CurrencyId" id="CurrencyId" data-plugin="select2">
                                    <option value="@((int)CurrencyEnum.Peso)" selected="@(Model.CurrencyId == (int)CurrencyEnum.Peso)">Peso</option>
                                    <option value="@((int)CurrencyEnum.Dolar)" selected="@(Model.CurrencyId == (int)CurrencyEnum.Dolar)">Dolar</option>
                                </select>
                            </div>
                            <div class="form-group col-sm-2">
                                <label class="control-label">Nro. Factura / Nro.Remito</label>
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        Nro.
                                    </span>
                                    <input type="text" class="form-control" name="InvoiceNumber" value="@Model.InvoiceNumber" />
                                </div>
                                
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="control-label">Observaciones</label>
                            <textarea class="form-control" name="Observations" rows="3">@Model.Observations</textarea>
                        </div>

                        <div class="form-group">
                            <h4>Detalle de la Compra</h4>

                            <table class="table table-bordered table-hover table-striped" id="productsTable">
                                <thead>
                                    <tr>
                                        <th class="text-left"   width="40%">Código de Producto</th>
                                        <th class="text-center" width="8%">Cantidad</th>
                                        @*<th>Units p/Box</th>*@
                                        <th class="text-center" width="12%">Precio Unitario</th>
                                        <th class="text-center" width="8%">IVA</th>
                                        <th class="text-center" width="11%">Imp.Int.</th>
                                        <th class="text-center" width="15%">Total</th>
                                        <th class="text-center" >Acciones</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @{int i = 1;}
                                    @foreach (var item in Model.PurchaseDetails)
                                    {
                                        <tr class="gradeA">
                                            <td>
                                                <select class="form-control" name="ProductId_@i" data-plugin="select2">
                                                    @if (TempData["Products"] != null)
                                                    {
                                                        var prod = ((SelectList)TempData["Products"]).FirstOrDefault(x => x.Value == item.ProductId.ToString());
                                                        <option value="@prod.Value" selected="selected">@prod.Text</option>
                                                    }
                                                </select>
                                            </td>
                                            <td>
                                                <input type="text" name="Quantity_@i" id="Quantity_@i" class="form-control input-block text-right numeric" value="@item.Quantity" onchange="setSubTotalItem('@i')" />
                                                <input type="hidden" name="PurchaseDetailId_@i" value="@item.PurchaseDetailId">
                                            </td>
                                            @*<td>
                                                <input type="text" name="UnitsPerBox_@i" id="UnitsPerBox_@i" class="form-control input-block text-right numeric" value="@item.UnitsPerBox" placeholder="0" />
                                            </td>*@
                                            <td>
                                                <div class="input-group">
                                                    <span class="input-group-addon">$</span>
                                                    <input type="text" class="form-control text-right" name="Price_@i" id="Price_@i" placeholder="" value="@item.Price.ToString().Replace(",",".")" onchange="setSubTotalItem('@i')">
                                                </div>
                                            </td>
                                            <td>
                                                <select class="form-control" name="IVA_Percent_@i" data-plugin="select2" onchange="setSubTotal();">
                                                    <option value="0" @(item.Iva_Percent.HasValue && item.Iva_Percent.Value == 0 ? "selected" : string.Empty)>0%</option>
                                                    <option value="10.5" @(item.Iva_Percent.HasValue && item.Iva_Percent.Value.ToString() == "10,50" ? "selected" : string.Empty)>10,5%</option>
                                                    <option value="21" @(item.Iva_Percent.HasValue && item.Iva_Percent.Value == 21 ? "selected" : string.Empty)>21%</option>
                                                </select>
                                            </td>
                                            <td>
                                                <div class="input-group">
                                                    <span class="input-group-addon">%</span>
                                                    <input type="text" class="form-control text-right" name="Internal_Tax_@i" id="Internal_Tax_@i" placeholder="0,00" value="@(item.Internal_Tax.HasValue ? item.Internal_Tax.ToString().Replace(",",".") : string.Empty)" onchange="setSubTotal();">
                                                </div>
                                            </td>
                                            <td class="Total">
                                                <div class="input-group">
                                                    <span class="input-group-addon">$</span>
                                                    <input type="text" class="form-control text-right subtotal" name="Subtotal_@i" id="Subtotal_@i" placeholder="0,00" value="@item.Subtotal.ToString().Replace(",",".")" readonly>
                                                </div>
                                            </td>
                                            <td class="actions text-center vertical-align">
                                                <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a>
                                            </td>
                                        </tr>
                                        i++;
                                    }
                                </tbody>
                                <tfoot>
                                    <tr class="active">
                                        <td>
                                            <button id="addToTable" class="btn btn-outline btn-primary" type="button">
                                                <i class="icon wb-plus" aria-hidden="true"></i> Agregar Producto
                                            </button>
                                        </td>
                                        <td class="text-right bold" colspan="4" style="font-weight:bold;vertical-align:middle;">SUBTOTAL</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="subtotal" id="subtotal" placeholder="0,00" value="" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="active hide row_total_pesos @(Model.CurrencyId == (int)CurrencyEnum.Peso ? "hide" : string.Empty)">
                                        <td class="text-right" style="font-weight:bold;vertical-align:middle;" colspan="4">SUBTOTAL ARS (x cambio)</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="ChangeRate" id="ChangeRate" placeholder="0,00" value="@(Model.ChangeRate.HasValue ? Model.ChangeRate.Value.ToString().Replace(",","."):string.Empty)" onchange="setSubTotal()">
                                            </div>
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="Subtotal_Pesos" id="Subtotal_Pesos" placeholder="0,00" value="" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="5" style="vertical-align:middle;">IMPUESTOS INTERNOS</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right tax" name="Internal_Tax" id="Internal_Tax" placeholder="0,00" value="@Model.Internal_Tax" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="5" style="vertical-align:middle;">IVA (10,5%)</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right tax" name="IVA_10" id="IVA_10" placeholder="0,00" value="" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="5" style="vertical-align:middle;">IVA (21%)</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right tax" name="IVA_21" id="IVA_21" placeholder="0,00" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="4" style="vertical-align:middle;">IIBB</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon" style="padding: 6px 11px;">%</span>
                                                <input type="text" class="form-control" name="IIBB_Percent" id="IIBB_Percent" placeholder="0,00" value="@(Model.IIBB_Percent.HasValue ? Model.IIBB_Percent.Value.ToString().Replace(",",".") : string.Empty)" onchange="setTaxes();">
                                            </div>
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right tax" name="IIBB" id="IIBB" placeholder="0,00" value="@(Model.IIBB.HasValue ? Model.IIBB.Value.ToString().Replace(",",".") : string.Empty)" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="active">
                                        <td class="text-right" style="font-weight:bold;vertical-align:middle;" colspan="5">TOTAL</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="Total" id="Total" placeholder="0,00" value="@Model.Total" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>

                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Purchases'">Cancelar</button>
                            @Html.HiddenFor(model => model.PurchaseId)
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>

    

</div>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.validation').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    SupplierId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Proveedor es requerido.'
                            }
                        }
                    },
                    Date: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Fecha es requerido.'
                            }
                        }
                    }
                }
            });
        })();

        $(document).ready(function ()
        {
            $("#addToTable").click(function ()
            {
                var row_number = $("#productsTable tr").length;

                var row = [
                    '<tr class="gradeA">',
                    '<td><select class="form-control" name="ProductId_' + row_number + '" id="ProductId_' + row_number + '" data-plugin="select2"><option value=""></option></select></td>',
                    '<td>',
                        '<input type="text" name="Quantity_' + row_number + '" id="Quantity_' + row_number + '" class="form-control input-block text-right" onchange="setSubTotalItem(' + row_number + ');" placeholder="0" />',
                        '<input type="hidden" name="PurchaseDetailId_'+ row_number +'" value="-1">',
                    '</td>',
                    //'<td><input type="text" name="UnitsPerBox_' + row_number + '" id="UnitsPerBox_' + row_number + '" class="form-control text-right input-block numeric" value="" placeholder="0" /></td>',
                    '<td><div class="input-group"><span class="input-group-addon">$</span><input type="text" class="form-control text-right" name="Price_' + row_number + '" id="Price_' + row_number + '" placeholder="$0,00" value="" onchange="setSubTotalItem(' + row_number + ');"></div></td>',
                    '<td><select class="form-control" name="IVA_Percent_' + row_number + '" id="IVA_Percent_' + row_number + '" data-plugin="select2" onchange="setSubTotal();">',
                        '<option value="0">0%</option>',
                        '<option value="10.5">10.5%</option>',
                        '<option value="21">21%</option>',
                    '</select></td>',
                    '<td><div class="input-group"><span class="input-group-addon">%</span><input type="text" class="form-control text-right" name="Internal_Tax_' + row_number + '" id="Internal_Tax_' + row_number + '" placeholder="0,00" value="" onchange="setSubTotal();"></div></td>',
                    '<td class="Total"><div class="input-group"><span class="input-group-addon">$</span><input type="text" class="form-control text-right subtotal" name="Subtotal_' + row_number + '" id="Subtotal_' + row_number + '" placeholder="$0,00" value="1" readonly></div></td>',
                    '<td class="actions text-center vertical-align"><a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a></td>',
                    '</tr>'
                ].join(' ');

                $("#productsTable").append(row);

                var products = $("#ProductId_" + row_number);
                GetProducts(products);
                $("#ProductId_" + row_number).select2();


            });

            $("#productsTable").on('click', '.remove-row', function () {
                $(this).parent().parent().remove();
            });

            if ($("#PurchaseId").val() > 0)
                setSubTotal();

            $("#CurrencyId").change(function ()
            {
                if ($(this).val() == "@((int)CurrencyEnum.Dolar)")
                {
                    $(".row_total_pesos").removeClass("hide");
                }
                else
                    $(".row_total_pesos").addClass("hide");

                setSubTotal();
            });
            $("#CurrencyId").change();
        });

        function setSubTotalItem(row_number)
        {
            var price = $("#Price_" + row_number).val().replace(",", ".");
            var quantity = $("#Quantity_" + row_number).val();

            if (price !== "" && quantity != "")
            {
                var subtotal = parseFloat(price) * parseFloat(quantity);
                $("#Subtotal_" + row_number).val(subtotal.toFixed(2));

                setSubTotal();
            }
        }

        var multiplicador = 1;
        function setSubTotal()
        {
            var subtotal = 0;
            $(".subtotal").each(function ()
            {
                if ($(this).val().trim() != "")
                    subtotal += parseFloat($(this).val().replace(",","."));
            });
            $("#subtotal").val(subtotal.toFixed(2));

            if ($("#CurrencyId").val() == "@((int)CurrencyEnum.Dolar)" && $("#ChangeRate").val().trim() != '')
            {
                multiplicador = $("#ChangeRate").val().replace(",", ".");
                var subtotal_pesos = subtotal * multiplicador;

                $("#Subtotal_Pesos").val(subtotal_pesos.toFixed(2));
            }
            else
            {
                multiplicador = 1;
                $("#Subtotal_Pesos").val(subtotal.toFixed(2));
            }

            setTaxes();
        }

        function setTaxes()
        {
            SetIva();

            SetIIBB();

            SetInternalTax();

            setTotal();
        }

        function setTotal()
        {
            var total = 0;
            total += parseFloat($("#Subtotal_Pesos").val().replace(",", "."));

            $(".tax").each(function () {
                if ($(this).val().trim() != "")
                    total += parseFloat($(this).val().replace(",", "."));
            });

            $("#Total").val(total.toFixed(2));
        }

        function GetProducts(control)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProducts",
                data: null,
                success: function (data)
                {
                    control.empty();
                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.ProductId + '>' + item.Code + ' - ' + item.Title + '</option>'));
                    });
                }
            });
        }

        function SetIva()
        {
            var base_10 = 0;
            var base_21 = 0;

            $("select[name*='IVA_Percent_']").each(function ()
            {
                var row_number = (this).name.split("IVA_Percent_")[1];

                if ($(this).val() == "10.5") {
                    base_10 += parseFloat($("#Subtotal_" + row_number).val().replace(",", ".")) * multiplicador * 0.105;
                }

                if ($(this).val() == "21") {
                    base_21 += parseFloat($("#Subtotal_" + row_number).val().replace(",", ".")) * multiplicador * 0.21;
                }
            });

            $("#IVA_10").val(base_10.toFixed(2));
            $("#IVA_21").val(base_21.toFixed(2));
        }

        function SetIIBB()
        {
            var subtotal = parseFloat($("#Subtotal_Pesos").val().replace(",", "."));
            var iibb_percent = $("#IIBB_Percent").val().trim();

            if (iibb_percent != "")
            {
                iibb_percent = parseFloat(iibb_percent);
                var iibb = subtotal * iibb_percent / 100;
                $("#IIBB").val(iibb.toFixed(2));
            }
            else
                $("#IIBB").val("");
        }

        function SetInternalTax()
        {
            var base = 0;
            $("input[name*='Internal_Tax_']").each(function ()
            {
                var row_number = (this).name.split("Internal_Tax_")[1];
                if ($(this).val().trim() != "" && $(this).val().replace(",", ".") > 0)
                {
                    var internal_tax = parseFloat($("#Internal_Tax_" + row_number).val().replace(",", "."));
                    var item_subtotal = parseFloat($("#Subtotal_" + row_number).val().replace(",", "."));

                    base += item_subtotal * multiplicador * (internal_tax / 100);
                }
            });

            $("#Internal_Tax").val(base.toFixed(2));
        }

    </script>


}

